const host = "https://node.code-company.co.jp";
// const host = "http://localhost:3000";

function isNullOrUndefined(o) {
    return (typeof o === "undefined" || o === null);
}


var status = false;
var authToken = "";
var targetLpUrl = "";
var disabled = false;
var targetHtml = "";
var submitUrl = "";
var optionCount = 0;
var resultData = "";
var abTag = "";
var csvTag = "";
var autoSupplyTabIds = {};
var autoSupplyTabCsvIds = {};
var csvCompanyId = "";

chrome.runtime.onMessage.addListener(
    function(request, sender, sendResponse) {
        if (request.message === "getTabId") {
            sendResponse({tabId: sender.tab.id});
        }
    }
);
  

chrome.runtime.onMessage.addListener((request, sender, sendResponse) => {
    if (request.type === "makeAjaxRequest") {
        var authToken = request.authToken;
        var csv_id = request.csv_id;
        var csv_log_status = request.csv_log_status;
        var csv_log_memo = request.csv_log_memo;

        $.ajax({
            url: host + "/api/csv_log",
            type: 'POST',
            data: {
                'authorization': authToken,
                'csv_id': csv_id,
                'csv_log_status': csv_log_status,
                'csv_log_memo': csv_log_memo
            }
        })
        .done((data) => {
            console.log(data);
            console.log("csv_logリクエスト送信成功");
            if (data != 401 && data != 500) {
            } else {
                $("#errMsg").html("認証:認証に失敗しました。オプションで認証トークンを確認してください。");
            }
            console.log(data);
        })
        .fail((data) => {
            console.log("通信失敗");
            console.log(data);
        })
        .always((data) => {
        });
    }
});

chrome.commands.onCommand.addListener((command) => {
    switch (command) {
      case "runUltraForm":
        chrome.storage.local.get(function (data) {
            var authToken = data.ULT_CNF_token;
            var latestTargetUrl = data.ULT_CNF_target_url;
            var targetLpUrl = data.ULT_CNF_targetLpUrl;
            var abTag = data.ULT_CNF_abTag;
            var csvTag = data.ULT_CNF_csvTag;
            autoSupplyTabCsvIds = data.ULT_CNF_autoSupplyTabIds;

            chrome.tabs.query({
                'active': true,
                'lastFocusedWindow': true
            }, tabs => {
                if (typeof tabs[0] == 'undefined') {
                    alert("ショートカットキー連打防止：エラーです。画面をリロードしてください。");
                    return false;
                }
                var openUrl = tabs[0].url
                if (latestTargetUrl == openUrl) {
                    alert("ショートカットキー連打防止：実行済です。\n再度同じURLで実行する場合はポップアップの自動入力を使用してください。");
                    return false;
                }

                chrome.tabs.sendMessage(tabs[0].id, {
                    text: "code-block"
                }, function (response) {
                    if(typeof response !== 'undefined'){
                        targetHtml = response.targetHtml;
                        submitUrl = response.submitUrl;
                        targetIframe = response.targetIframe;
                        targetLpUrl = targetLpUrl;
                        iframeFullUrl = response.iframeFullUrl;
                        isCors = response.isCors;
                        iframePossible = response.iframePossible;

                        // console.log("isCors:"+isCors+" iframeFullUrl:"+iframeFullUrl+" iframePossible:"+iframePossible);
                        if (isCors) {
                            if (iframePossible == "可能") {
                                $("#errMsg").html('可能：CORSエラー：問い合わせフォームは埋め込みされており自動入力を実行できません。<br>こちらを開いて再度実行を試してください。<br><a href="'+iframeFullUrl+'" target="_brank">リンクを開く</a>');
                            }else{
                                if (iframePossible == "不可能") {
                                    $("#errMsg").html('不可能：CORSエラー：問い合わせフォームは埋め込みされており自動入力を実行できません。<br><a href="'+iframeFullUrl+'" target="_brank">リンクを開く</a>');
                                }else{
                                    if (iframePossible == "不明") {
                                        $("#errMsg").html('不明：CORSエラー：問い合わせフォームは埋め込みされており自動入力を実行できません。<br><a href="'+iframeFullUrl+'" target="_brank">リンクを開く</a>');
                                    }else{
                                        $("#errMsg").html('不明2：CORSエラー：問い合わせフォームは埋め込みされており自動入力を実行できません。<br><a href="'+iframeFullUrl+'" target="_brank">リンクを開く</a>');
                                    }
                                }

                            }
                            
                            return false;
                        }else{
                            if (iframeFullUrl != undefined) {
                                console.log("iframeFullUrl  "+iframeFullUrl);
                                if (iframeFullUrl != "") {
                                    $("#errMsg").html('iFrameあり：自動入力できない場合はこちらをお試しください。<br><a href="'+iframeFullUrl+'" target="_brank">リンクを開く</a>');
                                }
    
                            }
                        }
                    } else {
                        return false;
                    }

                    var targetUrl = tabs[0].url;
                    var tabIndex = tabs[0].index;
                    var tabId = tabs[0].id;
                    
                    chrome.storage.local.set({
                        "ULT_CNF_target_url": targetUrl
                    });
                    chrome.storage.local.set({
                        "ULT_CNF_submit_url": submitUrl
                    });
                    chrome.storage.local.set({
                        "ULT_CNF_tab_id": tabId
                    });

                    // console.log(targetUrl,tabIndex,tabId);
                    if (typeof autoSupplyTabCsvIds !== 'undefined') {
                        if (typeof autoSupplyTabCsvIds[tabId] !== 'undefined') {
                            csvCompanyId = autoSupplyTabCsvIds[tabId];
                            // console.log(targetUrl,tabIndex,tabId,csvCompanyId);
                        }else{
                            // console.log("csvCompanyIdなし2");
                        }
                    }else{
                        // console.log("csvCompanyIdなし1");
                    }

                    $.ajax({
                            url: host + "/post-example",
                            type: 'POST',
                            data: {
                                'authorization': authToken,
                                'url': tabs[0].url,
                                'targetHtml': targetHtml,
                                'targetIframe': targetIframe,
                                'targetLpUrl': targetLpUrl,
                                'tabIndex': tabs[0].index,
                                'iframeFullUrl': iframeFullUrl,
                                'isCors': isCors,
                                'abTag': abTag,
                                'csvTag': csvTag,
                                'csvCompanyId': csvCompanyId,
                            }
                        })
                        // Ajaxリクエストが成功した時発動
                        .done((data) => {
                            console.log(data);
                            $("#successMsg").html("リクエスト送信成功");
                            console.log("リクエスト送信成功");
                            data["tabUrl"] = targetUrl;
                            data["tabIndex"] = tabIndex;
                            if (data["check_ng_res"]["isNg"] == true) {
                                if (data["check_ng_res"]["isNgUrl"] == true) {
                                    alert("Ultra Formアラート:営業禁止サイトです。サイトがUFの保有するNGリストに登録されています。");
                                }else{
                                    alert("Ultra Formアラート:営業禁止サイトです。サイトにNGワードが含まれています。");
                                }
                            }
                            
                            if (data != 401 && data != 500) {
                                chrome.storage.local.set({
                                    "ULT_CNF_result": data
                                });
                                // var reqApiCount = data.reqApiCount;
                                // $("#reqApiCount").html(reqApiCount);
                                $("#successMsg").html(data.message);

                                clipCopymain(data);


                            } else {
                                $("#errMsg").html("認証:認証に失敗しました。オプションで認証トークンを確認してください。");
                            }
                            console.log(data);
                        })
                        // Ajaxリクエストが失敗した時発動
                        .fail((data) => {
                            console.log("通信失敗");
                            console.log(data);
                        })
                        // Ajaxリクエストが成功・失敗どちらでも発動
                        .always((data) => {
                    });
                    
                });
            });
        });
        break;
        
        case "isUFCommand":
            chrome.storage.local.get(function (data) {
                var ULT_CNF_inputSupport = data.ULT_CNF_inputSupport;
                console.log("ULT_CNF_inputSupport");
                console.log(ULT_CNF_inputSupport);
                if (ULT_CNF_inputSupport) {
                    chrome.storage.local.set({
                        "ULT_CNF_inputSupport": false
                    });
                }else{
                    chrome.storage.local.set({
                        "ULT_CNF_inputSupport": true
                    });
                }

            });
        break;
    }
});

function z2h(str) {
    return str.replace(/[Ａ-Ｚａ-ｚ０-９]/g, function(s) {
        return String.fromCharCode(s.charCodeAt(0) - 0xFEE0);
    });
}

function clipCopymain(resultData) {
    console.log("resultData");
    console.log(resultData);
    chrome.storage.local.get(null, function (data) {
        console.log("data");
        console.log(data);
        $("#clipCopy").removeClass("copy-text-hidden");

            Object.entries(data).map(([name, obj]) => {
                if (obj.tagName == "問い合わせ内容") {
                    var jsonLpUrl = JSON.parse(resultData.lpUrl);
                    Object.keys(jsonLpUrl).forEach(function (key) {
                        var reg = "{LP_URL"+key+"}";
                        obj.val = obj.val.replace(new RegExp(reg,'g'), jsonLpUrl[key]);
                    });
                    // 変数削除
                    var lplurl = [1,2,3];
                    Object.keys(lplurl).forEach(function (key) {
                        var reg = "{LP_URL"+lplurl[key]+"}";
                        obj.val = obj.val.replace(new RegExp(reg,'g'), "");
                    });

                    // SITE_NAME差し込み
                    let autoSupplyName = z2h(data?.ULT_CNF_autoSupplyTabIds?.[data?.ULT_CNF_tab_id]?.autoSupplyName ?? "");
                    if (data.ULT_CNF_target_url == "https://code-company.co.jp/test/") {
                        autoSupplyName = "株式会社CODE COMPANY";
                    }
                    obj.val = obj.val.replace(/\{SITE_NAME(_[^\}]+)?\}/g, replaceSiteNamePlaceholder);
    
                    function replaceSiteNamePlaceholder(match, placeholderSuffix) {
                        if (!placeholderSuffix) {
                            return autoSupplyName;
                        }
    
                        const suffix = placeholderSuffix.slice(1); // Remove the leading underscore
                        if (suffix === "N") {
                            return autoSupplyName ? autoSupplyName + "\n" : "";
                        }
                        return autoSupplyName ? autoSupplyName + suffix.trim() : "";
                    }

                    // CLIENT_STAFF_NAME差し込み
                    let autoSupplyClientStaffName = z2h(data?.ULT_CNF_autoSupplyTabIds?.[data?.ULT_CNF_tab_id]?.autoSupplyClientStaffName ?? "");
                    if (data.ULT_CNF_target_url == "https://code-company.co.jp/test/") {
                        autoSupplyClientStaffName = "植田 歩";
                    }
                    obj.val = obj.val.replace(/\{CLIENT_STAFF_NAME(_[^\}]+)?\}/g, replaceClientStaffNamePlaceholder);
    
                    function replaceClientStaffNamePlaceholder(match, placeholderSuffix) {
                        console.log(placeholderSuffix);
                        if (!placeholderSuffix) {
                            return autoSupplyClientStaffName;
                        }
    
                        const suffix = placeholderSuffix.slice(1); // Remove the leading underscore
                        if (suffix === "N") {
                            return autoSupplyClientStaffName ? autoSupplyClientStaffName + "\n" : "";
                        }
                        return autoSupplyClientStaffName ? autoSupplyClientStaffName + suffix.trim() : "";
                    }
                    
                    // CLIENT_STAFF_POSITION差し込み
                    let autoSupplyClientStaffPosition = z2h(data?.ULT_CNF_autoSupplyTabIds?.[data?.ULT_CNF_tab_id]?.autoSupplyClientStaffPosition ?? "");
                    if (data.ULT_CNF_target_url == "https://code-company.co.jp/test/") {
                        autoSupplyClientStaffPosition = "代表取締役";
                    }
                    obj.val = obj.val.replace(/\{CLIENT_STAFF_POSITION(_[^\}]+)?\}/g, replaceClientStaffPositionPlaceholder);
    
                    function replaceClientStaffPositionPlaceholder(match, placeholderSuffix) {
                        console.log(placeholderSuffix);
                        if (!placeholderSuffix) {
                            return autoSupplyClientStaffPosition;
                        }
    
                        const suffix = placeholderSuffix.slice(1); // Remove the leading underscore
                        if (suffix === "N") {
                            return autoSupplyClientStaffPosition ? autoSupplyClientStaffPosition + "\n" : "";
                        }
                        return autoSupplyClientStaffPosition ? autoSupplyClientStaffPosition + suffix.trim() : "";
                    }
                                            
                    console.log("obj.val");
                    console.log(resultData[obj.tagName]);
                    console.log(obj.val);
                    var pushText = obj.val;
                    console.log(pushText);

                    // 初期化(別URLの処理と混同しないようするため)
                    chrome.storage.local.remove('ULT_CNF_clipCopymain', function (data) {});
                    chrome.storage.local.set({
                        "ULT_CNF_clipCopymain": pushText
                    });

                    $("#copyText").text(pushText);
                }
            });
    });
}

// Ultra Formからの送信情報を保存する（送信履歴管理機能）
chrome.webRequest.onBeforeRequest.addListener(
    function (details) {
        chrome.storage.local.get(function (storageData) {
            var authToken = storageData.ULT_CNF_token;
            var targetUrl = storageData.ULT_CNF_target_url;
            var submitUrl = storageData.ULT_CNF_submit_url;
            var tabId = storageData.ULT_CNF_tab_id;
            var autoInputResults = storageData.ULT_CNF_result;
            var postUrl = details.url;

            if (details.method == "POST" || details.method == "GET") {
                // Ultra Formが実行された時のtabIdと一致してるものだけを送信する。
                if (tabId == details.tabId && !isNullOrUndefined(autoInputResults) && !isNullOrUndefined(details.requestBody)) {
                    console.log(autoInputResults);
                    console.log(details.requestBody.formData);

                    $.ajax({
                            url: host + "/post/formData",
                            type: 'POST',
                            data: {
                                'authorization': authToken,
                                'targetUrl': targetUrl,
                                'postUrl': postUrl,
                                'autoInputResults': autoInputResults,
                                'formData': details.requestBody.formData,
                            }
                        })
                        // Ajaxリクエストが成功した時発動
                        .done((data) => {
                            console.log("bgリクエスト送信成功");

                            if (data != 401 && data != 500) {
                                console.log("bg通信OK" + data);
                            } else {
                                console.log("bg通信NG 認証エラー" + data);
                            }
                        })
                        // Ajaxリクエストが失敗した時発動
                        .fail((data) => {
                            console.log("bg通信失敗");
                            console.log(data);
                        })
                        // Ajaxリクエストが成功・失敗どちらでも発動
                        .always((data) => {});

                    chrome.storage.local.remove('ULT_CNF_submit_url', function (data) {});
                    chrome.storage.local.remove('ULT_CNF_result', function (data) {});

                }
            }
        });
    }, {
        urls: ["<all_urls>"]
    },
    ["requestBody"]
);