const host = "https://node.code-company.co.jp";
// const host = "http://localhost:3000";


$(function () {
  // INIT
  chrome.storage.local.get(null, function (data) {
    Object.entries(data).map(([name, obj]) => {
      console.log(obj.val);
      if (obj.type == "checkbox" && obj.val == true) {
        $("[name='" + obj.tagName + "']").prop("checked", true);
      }
      $("[name='" + obj.tagName + "']").val(obj.val);
    });
  });
  
  chrome.storage.local.get("ULT_CNF_token", function (data) {
    authToken = data.ULT_CNF_token;
    $("[name='authToken']").val(authToken);
  });
  // chrome.storage.local.remove('ULT_CNF_targetLpUrl', function (data) {});
  
  chrome.storage.local.get("ULT_CNF_targetLpUrl", function (data) {
    targetLpUrls = data.ULT_CNF_targetLpUrl;
    if (targetLpUrls !== undefined){
        if (typeof array === "undefined") {
          // 配列が未定義の場合の処理
        } else if (array.length) {
          // 空配列でない場合の処理
          targetLpUrls = JSON.parse(targetLpUrls);
          $("#targetLpUrl1").val(targetLpUrls.targetLpUrl1);
          $("#targetLpUrl2").val(targetLpUrls.targetLpUrl2);
          $("#targetLpUrl3").val(targetLpUrls.targetLpUrl3);
        } else {
          // 空配列の場合の処理
        }
    }
  });

  $('.auth').on('click', evt => {
    var token = $(".authToken").val();

    $.ajax({
        type: 'post',
        url: host + "/api/auth",
        dataType: 'json',
        beforeSend: function (xhr, settings) {
          xhr.setRequestHeader('Authorization', 'Bearer ' + token);
        }
      })
      .done(function (data) {
        console.log(data);
        var statusCode = data.statusCode;
        var message = data.message;
        if (statusCode != 401 && statusCode != 500) {
          alert(message);
          chrome.storage.local.set({
            "ULT_CNF_token": token
          });
        } else {
          alert("認証:失敗（連続で失敗する場合はトークンを再生成してください。）"+message);
        }
      })
      .fail(function (data) {
        console.log("認証API通信失敗");
        alert("認証API通信：失敗")
        console.log(data);
      });
  });

  $('.save').on('click', evt => {
    console.log("save");
    var fields = $('.targetField');
    var targetLpUrl1 = $("#targetLpUrl1").val();
    var targetLpUrl2 = $("#targetLpUrl2").val();
    var targetLpUrl3 = $("#targetLpUrl3").val();
    var abTag = $("#ULT_CNF_abTag").val();
    var csvTag = $("#ULT_CNF_csvTag").val();
    
    if (!validURL(targetLpUrl1) ||!validURL(targetLpUrl2) || !validURL(targetLpUrl3)) {
        alert('ランディングページURLに正しいURLを入力してください');
        return;
    }
    fields.each(function (index, element) {
      console.log(index + ':' + $(element).attr('name') + " " + $(element).attr('type'));
      if ($(element).attr('type') == "checkbox") {
        if ($(element).prop("checked")) {
          chrome.storage.local.set({
            [index]: {
              "tagName": $(element).attr('name'),
              "type": $(element).attr('type'),
              "val": true,
            }
          });
        } else {
          chrome.storage.local.set({
            [index]: {
              "tagName": $(element).attr('name'),
              "type": $(element).attr('type'),
              "val": false,
            }
          });
        }
      } else {
        chrome.storage.local.set({
          [index]: {
            "tagName": $(element).attr('name'),
            "type": $(element).attr('type'),
            "val": $(element).val(),
          }
        });
      }

      var targetLpUrls = '{ "targetLpUrl1" : "'+targetLpUrl1+'","targetLpUrl2" : "'+targetLpUrl2+'","targetLpUrl3" : "'+targetLpUrl3+'"}';
      chrome.storage.local.set({
        "ULT_CNF_targetLpUrl": targetLpUrls
      });
      chrome.storage.local.set({
        "ULT_CNF_abTag": abTag
      });
      chrome.storage.local.set({
        "ULT_CNF_csvTag": csvTag
      });
    });
    alert('設定の保存に成功しました。');
  });

  $('#export').on('click', evt => {
    handleExport(evt);
  });

  $('#import').on('change', evt => {
    handleImport(evt);
    window.location.reload();
  });

  $('#clearAll').on('click', evt => {
    if (window.confirm("保存されているデータを全て削除してよろしいですか?")) {
      clearStorage();
      window.location.reload();
    }
  });
});

// ストレージに保存されているデータをJson形式に変換
function storageToJson() {
  return new Promise((resolve, reject) => {
    chrome.storage.local.get(null, function (data) {
      resolve(data);
    });
  });
}

// エクスポート処理
async function handleExport(evt) {
  var content = await storageToJson();
  delete content["ULT_CNF_token"]

  const blob = new Blob([JSON.stringify(content)], {
    "type": 'application/json'
  });
  let anchor = document.createElement("a");
  anchor.download = `ultra_form_${Date.now()}.json`;
  anchor.href = window.URL.createObjectURL(blob);
  anchor.click();
}

// ストレージに保存
function setStorage(name, obj) {
  chrome.storage.local.set({
    [name]: {
      "tagName": obj.tagName,
      "type": obj.type,
      "val": obj.val,
    }
  });
}

// インポート処理
async function handleImport(evt) {
  let reader = new FileReader();
  reader.readAsText(evt.target.files[0]);
  reader.onload = () => {
    const data = JSON.parse(reader.result);
    Object.entries(data).map(([name, obj]) => {
      if (name !== "ULT_CNF_token") {
        console.log(name);
        setStorage(name, obj);
      }
    });
    alert('インポート処理成功です。必ず『設定を保存』を押してください。');
  }
}

// ストレージに保存されているデータを全削除
function clearStorage() {
  chrome.storage.local.clear();
}

$(document).ready(function () {
  $(".btn_import .txt").text("選択されていません");
  $(".btn_import input[type=file]").change(function () {
    var fileName = $(this).prop("files")[0].name;
    $(".btn_import").addClass("selected");
    $(".btn_import").addClass("active");
    $(".btn_import .txt").text(fileName);
  });

  $(window).on("load resize", function () {
    if ($(".menu").css("display") == "flex") {
      if (!$(".btn_import").hasClass("selected")) {
        $(".btn_import").removeClass("active");
      }
    }
  });
});


function validURL(url) {
  if (url == "") {
    return true;
  }
  const reg = /^(https?|ftp)(:\/\/[-_.!~*\'()a-zA-Z0-9;\/?:\@&=+\$,%#]+)$/;
  // const reg = /^(https?|ftp):\/\/([a-zA-Z0-9.-]+(:[a-zA-Z0-9.&%$-]+)*@)*((25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]?)(\.(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9]?[0-9])){3}|([a-zA-Z0-9-]+\.)*[a-zA-Z0-9-]+\.(com|edu|gov|int|mil|net|org|biz|arpa|info|name|pro|aero|coop|museum|[a-zA-Z]{2}))(:[0-9]+)*(\/($|[a-zA-Z0-9.,?'\\+&%$#=~_-]+))*$/;
  return reg.test(url);
}