const host = "https://node.code-company.co.jp";
// const host = "http://localhost:3000";

var status = false;
var authToken = "";
var targetLpUrl = "";
var disabled = false;
var disabledCsvSupply = false;
var targetHtml = "";
var submitUrl = "";
var optionCount = 0;
var resultData = "";
var abTag = "";
var csvTag = "";
var autoSupplyTabIds = {};
var autoSupplyTabCsvIds = {};
var csvCompanyId = "";

$.getJSON("../manifest.json")
.done(function (json) {
    console.log(json.version);
    $("h1").text("Ultra Form v"+json.version);
}).fail(function () {
}).always(function () {
});

chrome.storage.local.get("ULT_CNF_inputSupport", function (data) {
    if (typeof data.ULT_CNF_inputSupport !== 'undefined') {
        $("#is-conf-check").prop("checked", data.ULT_CNF_inputSupport);
    }else{
        $("#is-conf-check").prop("checked", "false");
        chrome.storage.local.set({
            "ULT_CNF_inputSupport": false
        });
    }
});

chrome.storage.local.get("ULT_CNF_forcedHeader", function (data) {
    if (typeof data.ULT_CNF_forcedHeader !== 'undefined') {
        $("#is-conf-check2").prop("checked", data.ULT_CNF_forcedHeader);
    }else{
        $("#is-conf-check2").prop("checked", "false");
        chrome.storage.local.set({
            "ULT_CNF_forcedHeader": false
        });
    }
});


chrome.storage.local.get(null, function (data) {
    Object.entries(data).map(([name, obj]) => {
        if (obj.val) {
            optionCount++;
        }
    });
    if (optionCount < 1) {
        $("#errMsg").html("設定が未入力です。オプションから自動入力する内容を設定してください。");
    }
});

$(function () {


    $('#is-conf-check').on('change', function () {
        chrome.storage.local.set({
            "ULT_CNF_inputSupport": $("#is-conf-check").prop('checked')
        });
    });
    $('#is-conf-check2').on('change', function () {
        chrome.storage.local.set({
            "ULT_CNF_forcedHeader": $("#is-conf-check2").prop('checked')
        });
    });

    

    $('#ajaxAutoSupply').on('click', function () {
        // console.log("ajaxAutoSupply clicked");
        $("#successMsg").html("URL自動供給開始");
        chrome.storage.local.get("ULT_CNF_token", function (data) {
            authToken = data.ULT_CNF_token;
            $.ajax({
                url: host + "/ajax-auto-supply",
                type: 'POST',
                data: {
                    'authorization': authToken,
                }
            })
            .done((data) => {
                console.log(data);
                $("#successMsg").html("URL自動供給成功");
    
                if (data != 401 && data != 500) {
                    $("#successMsg").html(data.message);
                    for (var i in data.autoSupplyUrls) {
                        chrome.tabs.create({
                            url: data.autoSupplyUrls[i],
                            active: false
                        });
                    }
            
                } else {
                    $("#errMsg").html("認証:認証に失敗しました。オプションで認証トークンを確認してください。");
                }
                console.log(data);
            })
            .fail((data) => {
                console.log("通信失敗");
                console.log(data);
            })
            .always((data) => {
            });
    
        });
    });

    $('#ajaxCsvSupply').on('click', function () {
        console.log("ajaxCsvSupply clicked");
        if (disabledCsvSupply) {
            $("#successMsg").html("");
            $("#errMsg").html("CSV供給誤連打防止：実行済です。ポップアップを閉じてください。");
            return false;
        }
        disabledCsvSupply = true;

        $("#successMsg").html("URLCSV供給開始");
        chrome.storage.local.get(function (storageData) {
            var authToken = storageData.ULT_CNF_token;
            var csvTag = storageData.ULT_CNF_csvTag;

            $.ajax({
                url: host + "/ajax-csv-supply",
                type: 'POST',
                data: {
                    'authorization': authToken,
                    'csvTag': csvTag
                }
            })
            .done((data) => {
                $("#successMsg").html("URLCSV供給成功");

                if (data != 401 && data != 500) {
                    $("#successMsg").html(data.message);
                    const openTabsProcess = (autoSupplyUrl = null, csvId = null) => new Promise(resolve => {
                        (async () => {
                            chrome.tabs.create({
                                url: autoSupplyUrl,
                                active: false
                            }, (tab) => {
                                var tabId = tab.id;
                                autoSupplyTabIds[tabId] = {tabId:tabId, autoSupplyUrl:autoSupplyUrl, csvId:csvId, autoSupplyName:data.autoSupplyNames[csvId], autoSupplyClientStaffName:data.autoSupplyClientStaffNames[csvId], autoSupplyClientStaffPosition:data.autoSupplyClientStaffPositions[csvId]}; 
                                chrome.storage.local.set({"ULT_CNF_autoSupplyTabIds": autoSupplyTabIds});
                                resolve("resolve")
                            });
                        })();
                    });
                    for (var csvId in data.autoSupplyUrls) {
                        (async () => {
                            let openTabsData = await openTabsProcess(data.autoSupplyUrls[csvId], csvId);
                            await chrome.storage.local.get(null, ((data) => {console.log(data.ULT_CNF_autoSupplyTabIds)}));
                        })();
                    }


                    if (data.autoSupplyUrls.length <= 0) {
                        // $("#successMsg").html("CSVから供給するURLが0件のため表示できません。");
                        $("#successMsg").html(data.message);
                    }
                } else {
                    $("#errMsg").html("認証:認証に失敗しました。オプションで認証トークンを確認してください。");
                }
                // console.log(data);
            })
            .fail((data) => {
                console.log("通信失敗");
                console.log(data);
            })
            .always((data) => {
            });
    
        });
    });

    

    
    $('#ajax').on('click', function () {
        console.log("ajax clicked");
        $("#successMsg").html("自動入力開始<br>完了しない場合は画面のリロードを試してください。");

        if (disabled) {
            $("#successMsg").html("");
            $("#errMsg").html("誤連打防止：実行済です。ポップアップを閉じてください。");
            return false;
        }
        disabled = true;
        chrome.storage.local.get("ULT_CNF_targetLpUrl", function (data) {
            targetLpUrl = data.ULT_CNF_targetLpUrl;
        });
        chrome.storage.local.get("ULT_CNF_abTag", function (data) {
            abTag = data.ULT_CNF_abTag;
        });
        chrome.storage.local.get("ULT_CNF_csvTag", function (data) {
            csvTag = data.ULT_CNF_csvTag;
        });

        chrome.storage.local.get(null, ((data) => {
            targetLpUrl = data.ULT_CNF_targetLpUrl;
            abTag = data.ULT_CNF_abTag;
            csvTag = data.ULT_CNF_csvTag;
            autoSupplyTabCsvIds = data.ULT_CNF_autoSupplyTabIds;

            authToken = data.ULT_CNF_token;
            chrome.tabs.query({
                'active': true,
                'lastFocusedWindow': true
            }, tabs => {
                if (typeof tabs[0] == 'undefined') {
                    $("#successMsg").html("");
                    $("#errMsg").html("画面をリロードしてください。");
                    return false;
                }
                chrome.tabs.sendMessage(tabs[0].id, {
                    text: "code-block"
                }, function (response) {
                    if(typeof response !== 'undefined'){
                        targetHtml = response.targetHtml;
                        submitUrl = response.submitUrl;
                        targetIframe = response.targetIframe;
                        targetLpUrl = targetLpUrl;
                        iframeFullUrl = response.iframeFullUrl;
                        isCors = response.isCors;
                        iframePossible = response.iframePossible;

                        // console.log("isCors:"+isCors+" iframeFullUrl:"+iframeFullUrl+" iframePossible:"+iframePossible);
                        if (isCors) {
                            if (iframePossible == "可能") {
                                $("#errMsg").html('可能：CORSエラー：問い合わせフォームは埋め込みされており自動入力を実行できません。<br>こちらを開いて再度実行を試してください。<br><a href="'+iframeFullUrl+'" target="_brank">リンクを開く</a>');
                            }else{
                                if (iframePossible == "不可能") {
                                    $("#errMsg").html('不可能：CORSエラー：問い合わせフォームは埋め込みされており自動入力を実行できません。<br><a href="'+iframeFullUrl+'" target="_brank">リンクを開く</a>');
                                }else{
                                    if (iframePossible == "不明") {
                                        $("#errMsg").html('不明：CORSエラー：問い合わせフォームは埋め込みされており自動入力を実行できません。<br><a href="'+iframeFullUrl+'" target="_brank">リンクを開く</a>');
                                    }else{
                                        $("#errMsg").html('不明2：CORSエラー：問い合わせフォームは埋め込みされており自動入力を実行できません。<br><a href="'+iframeFullUrl+'" target="_brank">リンクを開く</a>');
                                    }
                                }

                            }
                            
                            return false;
                        }else{
                            if (iframeFullUrl != undefined) {
                                console.log("iframeFullUrl  "+iframeFullUrl);
                                if (iframeFullUrl != "") {
                                    $("#errMsg").html('iFrameあり：自動入力できない場合はこちらをお試しください。<br><a href="'+iframeFullUrl+'" target="_brank">リンクを開く</a>');
                                }
    
                            }
                        }
                    } else {
                        return false;
                    }

                    var targetUrl = tabs[0].url;
                    var tabIndex = tabs[0].index;
                    var tabId = tabs[0].id;
                    
                    chrome.storage.local.set({
                        "ULT_CNF_target_url": targetUrl
                    });
                    chrome.storage.local.set({
                        "ULT_CNF_submit_url": submitUrl
                    });
                    chrome.storage.local.set({
                        "ULT_CNF_tab_id": tabId
                    });

                    // console.log(targetUrl,tabIndex,tabId);
                    if (typeof autoSupplyTabCsvIds !== 'undefined') {
                        if (typeof autoSupplyTabCsvIds[tabId] !== 'undefined') {
                            csvCompanyId = autoSupplyTabCsvIds[tabId];
                            // console.log(targetUrl,tabIndex,tabId,csvCompanyId);
                        }else{
                            // console.log("csvCompanyIdなし2");
                        }
                    }else{
                        // console.log("csvCompanyIdなし1");
                    }
                    
                    $.ajax({
                            url: host + "/post-example",
                            type: 'POST',
                            data: {
                                'authorization': authToken,
                                'url': tabs[0].url,
                                'targetHtml': targetHtml,
                                'targetIframe': targetIframe,
                                'targetLpUrl': targetLpUrl,
                                'tabIndex': tabs[0].index,
                                'iframeFullUrl': iframeFullUrl,
                                'isCors': isCors,
                                'abTag': abTag,
                                'csvTag': csvTag,
                                'csvCompanyId': csvCompanyId,
                            }
                        })
                        // Ajaxリクエストが成功した時発動
                        .done((data) => {
                            console.log(data);
                            $("#successMsg").html("リクエスト送信成功");
                            console.log("リクエスト送信成功");
                            data["tabUrl"] = targetUrl;
                            data["tabIndex"] = tabIndex;
                            if (data["check_ng_res"]["isNg"] == true) {
                                if (data["check_ng_res"]["isNgUrl"] == true) {
                                    alert("Ultra Formアラート:営業禁止サイトです。サイトがUFの保有するNGリストに登録されています。");
                                }else{
                                    alert("Ultra Formアラート:営業禁止サイトです。サイトにNGワードが含まれています。");
                                }
                            }

                            if (data != 401 && data != 500) {
                                chrome.storage.local.set({
                                    "ULT_CNF_result": data
                                });
                                // var reqApiCount = data.reqApiCount;
                                // $("#reqApiCount").html(reqApiCount);
                                $("#successMsg").html(data.message);

                                clipCopymain(data);


                            } else {
                                $("#errMsg").html("認証:認証に失敗しました。オプションで認証トークンを確認してください。");
                            }
                            console.log(data);
                        })
                        // Ajaxリクエストが失敗した時発動
                        .fail((data) => {
                            console.log("通信失敗");
                            console.log(data);
                        })
                        // Ajaxリクエストが成功・失敗どちらでも発動
                        .always((data) => {
                    });
                    
                });
            });
        }));
    });

    function z2h(str) {
        return str.replace(/[Ａ-Ｚａ-ｚ０-９]/g, function(s) {
            return String.fromCharCode(s.charCodeAt(0) - 0xFEE0);
        });
    }

    function clipCopymain(resultData) {
        console.log("resultData");
        console.log(resultData);
        chrome.storage.local.get(null, function (data) {
            console.log("data");
            console.log(data);
            $("#clipCopy").removeClass("copy-text-hidden");

                Object.entries(data).map(([name, obj]) => {
                    if (obj.tagName == "問い合わせ内容") {
                        var jsonLpUrl = JSON.parse(resultData.lpUrl);
                        Object.keys(jsonLpUrl).forEach(function (key) {
                            var reg = "{LP_URL"+key+"}";
                            obj.val = obj.val.replace(new RegExp(reg,'g'), jsonLpUrl[key]);
                        });
                        // 変数削除
                        var lplurl = [1,2,3];
                        Object.keys(lplurl).forEach(function (key) {
                            var reg = "{LP_URL"+lplurl[key]+"}";
                            obj.val = obj.val.replace(new RegExp(reg,'g'), "");
                        });

                        // SITE_NAME差し込み
                        let autoSupplyName = z2h(data?.ULT_CNF_autoSupplyTabIds?.[data?.ULT_CNF_tab_id]?.autoSupplyName ?? "");
                        if (data.ULT_CNF_target_url == "https://code-company.co.jp/test/") {
                            autoSupplyName = "株式会社CODE COMPANY";
                        }
                        obj.val = obj.val.replace(/\{SITE_NAME(_[^\}]+)?\}/g, replaceSiteNamePlaceholder);
        
                        function replaceSiteNamePlaceholder(match, placeholderSuffix) {
                            if (!placeholderSuffix) {
                                return autoSupplyName;
                            }
        
                            const suffix = placeholderSuffix.slice(1); // Remove the leading underscore
                            if (suffix === "N") {
                                return autoSupplyName ? autoSupplyName + "\n" : "";
                            }
                            return autoSupplyName ? autoSupplyName + suffix.trim() : "";
                        }

                        // CLIENT_STAFF_NAME差し込み
                        let autoSupplyClientStaffName = z2h(data?.ULT_CNF_autoSupplyTabIds?.[data?.ULT_CNF_tab_id]?.autoSupplyClientStaffName ?? "");
                        if (data.ULT_CNF_target_url == "https://code-company.co.jp/test/") {
                            autoSupplyClientStaffName = "植田 歩";
                        }
                        obj.val = obj.val.replace(/\{CLIENT_STAFF_NAME(_[^\}]+)?\}/g, replaceClientStaffNamePlaceholder);
        
                        function replaceClientStaffNamePlaceholder(match, placeholderSuffix) {
                            console.log(placeholderSuffix);
                            if (!placeholderSuffix) {
                                return autoSupplyClientStaffName;
                            }
        
                            const suffix = placeholderSuffix.slice(1); // Remove the leading underscore
                            if (suffix === "N") {
                                return autoSupplyClientStaffName ? autoSupplyClientStaffName + "\n" : "";
                            }
                            return autoSupplyClientStaffName ? autoSupplyClientStaffName + suffix.trim() : "";
                        }
                        
                        // CLIENT_STAFF_POSITION差し込み
                        let autoSupplyClientStaffPosition = z2h(data?.ULT_CNF_autoSupplyTabIds?.[data?.ULT_CNF_tab_id]?.autoSupplyClientStaffPosition ?? "");
                        if (data.ULT_CNF_target_url == "https://code-company.co.jp/test/") {
                            autoSupplyClientStaffPosition = "代表取締役";
                        }
                        obj.val = obj.val.replace(/\{CLIENT_STAFF_POSITION(_[^\}]+)?\}/g, replaceClientStaffPositionPlaceholder);
        
                        function replaceClientStaffPositionPlaceholder(match, placeholderSuffix) {
                            console.log(placeholderSuffix);
                            if (!placeholderSuffix) {
                                return autoSupplyClientStaffPosition;
                            }
        
                            const suffix = placeholderSuffix.slice(1); // Remove the leading underscore
                            if (suffix === "N") {
                                return autoSupplyClientStaffPosition ? autoSupplyClientStaffPosition + "\n" : "";
                            }
                            return autoSupplyClientStaffPosition ? autoSupplyClientStaffPosition + suffix.trim() : "";
                        }
                        
                                                
                        console.log("obj.val");
                        console.log(resultData[obj.tagName]);
                        console.log(obj.val);
                        var pushText = obj.val;
                        console.log(pushText);

                        // 初期化(別URLの処理と混同しないようするため)
                        chrome.storage.local.remove('ULT_CNF_clipCopymain', function (data) {});
                        chrome.storage.local.set({
                            "ULT_CNF_clipCopymain": pushText
                        });

                        $("#copyText").text(pushText);
                    }
                });
        });
    }



});

$(document).on('click', '#clipCopy', function () {
	function clipCopy() {
		var copytext = document.getElementById('copyText');
        $("#copyText").removeClass("copy-text-hidden");
        // var copytext = $("#copyText").text(pushText);

			try {
				copytext.readOnly = false;
				var range = document.createRange();
				range.selectNode(copytext);
				window.getSelection().addRange(range);
				document.execCommand("copy");
                $("#copyText").addClass("copy-text-hidden");
                $("#copySuccessMsg").html("コピー成功");

				// copytext.readOnly = true;
				// alert("URLをコピーしました。"+copytext);
			} catch (e) {
				// copytext.readOnly = true;
                $("#copySuccessMsg").html("エラーが発生したためコピーできませんでした。お問い合わせください。");
                console.log(e);
			}
	
	};
    clipCopy();
});

function isEmpty(obj) {
    return !Object.keys(obj).length;
}

$(document).ready(function () {
    status = get_status();
});

$(document).on('change', '#toggleCheckbox', function () {
    status = $('#toggleCheckbox').prop('checked');
    change_status(status);
});

$(document).on('click', '#reloadBtn', function () {
    chrome.storage.local.set({
        "ULT_CNF_reload_status": "" + Date.now()
    });
});

$(document).on('click', '#reflectOnceBtn', function () {
    chrome.tabs.query({
        'active': true,
        'lastFocusedWindow': true
    }, tabs => {
        chrome.storage.local.set({
            "ULT_CNF_reflectOnce": tabs[0].url
        });
    });
});

// chrome.storage のデータを監視、動きがあったら反映する
chrome.storage.onChanged.addListener(function (changes, namespace) {
    if (namespace == "local") {
        if (changes.ULT_CNF_check_status !== undefined) {
            disp_status(changes.ULT_CNF_check_status.newValue);
        }
    }
});

function get_status() {
    chrome.storage.local.get("ULT_CNF_check_status", function (data) {
        status = data.ULT_CNF_check_status;
        disp_status(status);
    });
}

function change_status(status) {
    chrome.storage.local.set({
        "ULT_CNF_check_status": status
    });
}

function disp_status(status) {
    if (status === "true") {
        $("#toggleCheckbox").prop('checked', true);
    } else {
        $("#toggleCheckbox").prop('checked', false);
    }
}