var resultData = "";
var inputSupport = false;

function z2h(str) {
    return str.replace(/[Ａ-Ｚａ-ｚ０-９]/g, function(s) {
        return String.fromCharCode(s.charCodeAt(0) - 0xFEE0);
    });
}

// ULT_CNF_result初期化
chrome.storage.local.remove('ULT_CNF_result', function (data) {});

chrome.storage.local.get("ULT_CNF_inputSupport", function (data) {
    if (typeof data.ULT_CNF_inputSupport !== 'undefined') {
        inputSupport = data.ULT_CNF_inputSupport;
    }else{
        inputSupport = false;
        chrome.storage.local.set({
            "ULT_CNF_inputSupport": false
        });
    }
});

chrome.runtime.onMessage.addListener(function (request, sender, sendResponse) {
    if (request.text == "code-block") {
        var targetIframe = null;
        var submitUrl = "";
        var targetHtml = document.body.outerHTML;
        // var isResponse = false;

        // iframe判別 ------
        var targetIframe = document.getElementsByTagName("iframe")[0];
        if (typeof targetIframe !== 'undefined') {
            var iframeFullUrl = targetIframe.src;
            if (iframeFullUrl != "") {
                var matchResult = iframeFullUrl.match(/^https?:\/{2,}.*?(\/)/);
                if (matchResult !== null) {
                    var iframeUrl = matchResult[0];
                    // var iframeUrl = iframeFullUrl.match(/^https?:\/{2,}.*?(\/)/)[0];
                    var iframeRegUrl = new RegExp('^' + iframeUrl)
                    
                    var safeList = ["https://form.run/", "https://smoothcontact.jp/", "https://contents.bownow.jp/", "https://airtable.com/", "https://ws.formzu.net/","https://opossum.jp/","https://smoothcontact.jp/"];
                    var deniedList = ["https://form.movabletype.net/"];
                    var corsList = safeList.concat(deniedList);
                    var regres = corsList.filter(RegExp.prototype.test.bind(iframeRegUrl));
                    var safeListReg = safeList.filter(RegExp.prototype.test.bind(iframeRegUrl));
                    var deniedListReg = deniedList.filter(RegExp.prototype.test.bind(iframeRegUrl));
                    var isCors = false;
                    var iframePossible = "不明";
                    // iframeのCORS特別対応
                    if (regres.indexOf(regres[0]) >= 0) {
                        isCors = true;
                    }
                    if (regres.indexOf(safeListReg[0]) >= 0) {
                        iframePossible = "可能";
                    }
                    if (regres.indexOf(deniedListReg[0]) >= 0) {
                        iframePossible = "不可能";
                    }
                    // console.log("iframePossible:"+iframePossible+" isCors:"+isCors);
                }else{
                }
            }


            try {
                targetIframe = targetIframe.contentWindow.document.body.innerHTML;
                // console.log("iframe取得");
            } catch (e) {
                console.log("例外発生1");
                console.log(e);
                try {
                    $("form")[0].action;
                } catch (e) {
                    console.log("例外発生2");
                    console.log(e);
                    sendResponse({
                        "iframeFullUrl": iframeFullUrl,
                        "isCors": isCors,
                        "iframePossible": iframePossible,
                    });
                }
            }
        } else {
            try {
                // console.log("通常取得");
                $("form")[0].action;
            } catch (e) {
                console.log("例外発生3");
                console.log(e);
                // isResponse = false;
            }
        }
        // iframe判別 ------


        sendResponse({
            "targetHtml": targetHtml,
            "submitUrl": submitUrl,
            "targetIframe": targetIframe,
            "iframeFullUrl": iframeFullUrl,
            "isCors": isCors,
            "iframePossible": iframePossible,
        });
    } else {
        // 空でいいのでレスポンス返す
        sendResponse({});
        return true;
    }
});

// chrome拡張機能のイベントリスナー
chrome.storage.onChanged.addListener(function (changes, namespace) {
    if (namespace == "local") {
        if (changes.ULT_CNF_result !== undefined) {
            chrome.storage.local.get("ULT_CNF_result", function (data) {
                if (!isEmpty(data)) {
                    if (data.ULT_CNF_result.tabUrl == location.href) {
                        resultData = data.ULT_CNF_result;
                        if (resultData.isNg) {
                            alert("NGリスト該当しました。このサイトは送信禁止です。");
                        }
                        main(resultData);
                    }
                }
            });
        } else {
            if (changes.ULT_CNF_inputSupport !== undefined) {
                chrome.storage.local.get("ULT_CNF_inputSupport", function (data) {
                    inputSupport = data.ULT_CNF_inputSupport;
                });
            }else{
                // console.log("通信反映失敗：undefined");
                // console.log(changes.ULT_CNF_result);
            }
        }
    } else {
        // 空でいいのでレスポンス返す
        sendResponse({});
        return true;
    }
});


chrome.runtime.sendMessage({message: "getTabId"}, function(response) {
    var currentTabId = response.tabId;
    // console.log("現在のタブID:", currentTabId);
    chrome.storage.local.get(null, function (storageData) {
        console.log("ULT_CNF_content.js");
        console.log(storageData);
        var isForcedHeader = storageData.ULT_CNF_forcedHeader??"";
        var csvId = storageData?.ULT_CNF_autoSupplyTabIds?.[currentTabId]?.csvId ?? "";
        console.log("csvId:", csvId);
        console.log("isForcedHeader:", isForcedHeader);

        if (csvId != "" && isForcedHeader == true) {
            $("body").append(`
                <div id="uf-cnf-forced-header">
                    <div class="uf-cnf-header-container">
                        <button id="uf-cnf-forced-header-close-button">X</button>
                        <form action="/csv/log" method="post">
                            
                            <label for="uf-cnf-csv_log_status" id="uf-cnf-csv_log_status_label">
                                Ultra Form
                            </label>
                            <select name="uf-cnf-csv_log_status" id="uf-cnf-csv_log_status" class="">
                                <option value="成功">成功</option>
                                <option value="入力エラー">入力エラー</option>
                                <option value="フォーム無し">フォーム無し</option>
                                <option value="項目無しor必須">項目無しor必須</option>
                                <option value="送信エラー">送信エラー</option>
                                <option value="リンク切れ">リンク切れ</option>
                                <option value="サイトエラー">サイトエラー</option>
                                <option value="アクセス不可">アクセス不可</option>
                                <option value="営業禁止">営業禁止</option>
                                <option value="文字数オーバー">文字数オーバー</option>
                                <option value="URL記載禁止">URL記載禁止</option>
                                <option value="メールのみ">メールのみ</option>
                                <option value="ノーカウント">ノーカウント</option>
                                <option value="その他">その他</option>
                            </select>
                            <input type="hidden" id="uf-cnf-csv_log_csv_id" value="${ csvId }">
                            <input type="text" id="uf-cnf-csv_log_memo" value="" placeholder="メモ">
                        </form>
                        <span id="uf-cnf-forced-header-message">●</span>
                    </div>
                </div>
        
                <style>
                    #uf-cnf-forced-header-close-button {
                        position: absolute;
                        top: 10px;
                        right: 10px;
                        background-color: rgba(0,0,0,0);
                        color: white;
                        border: none;
                        cursor: pointer;
                        padding: 5px 10px;
                        border-radius: 2px;
                        font-size: 16px;
                        z-index: 2147483648 !important; /* 他の要素より上に表示されるようにする */
                    }
                    
                    #uf-cnf-forced-header-close-button:hover {
                        background-color: #000;
                    }
         

                    #uf-cnf-forced-header {
                        position: fixed !important;
                        top: 0px !important;
                        left: 0 !important;
                        right: 0 !important;
                        background: -moz-linear-gradient(323deg, #71E0AD, #00C6A9) !important;
                        background: -webkit-linear-gradient(323deg, #71E0AD, #00C6A9) !important;
                        background: linear-gradient(323deg, #71E0AD, #00C6A9) !important;
                        color: white !important;
                        z-index: 2147483647 !important;
                        padding: 10px 0 !important;
                        text-align: center !important;
                        height: 80px !important;
                        box-sizing: border-box !important;
                        border: none !important;
                        font-family: Arial, sans-serif !important;
                        font-weight: normal !important;
                    }
                    
                    #uf-cnf-forced-header p {
                        margin: 0 !important;
                        font-size: 14px !important;
                        line-height: 1.5 !important;
                        color: #fff !important;
                        font-family: Arial, sans-serif !important;
                        font-weight: normal !important;
                    }
                    
                    #uf-cnf-forced-header select {
                        background-color: #fff !important;
                        padding: 5px !important;
                        color: #464a4c !important;
                        border-radius: 0 !important;
                        margin-bottom: 10px !important;
                        margin-top: 10px !important;
                        margin-right: 20px !important;
                        margin-left: 20px !important;
                        width: 200px !important;
                        font-size: 17px !important;
                        height: 41px !important;
                        box-sizing: border-box !important;
                        border: none !important;
                    }
                    
                    #uf-cnf-forced-header input {
                        background-color: #fff !important;
                        padding: 9px !important;
                        color: #464a4c !important;
                        border-radius: 0 !important;
                        margin-bottom: 10px !important;
                        margin-top: 10px !important;
                        margin-right: 20px !important;
                        margin-left: 20px !important;
                        width: 300px !important;
                        font-size: 17px !important;
                        height: 41px !important;
                        box-sizing: border-box !important;
                        border: none !important;
                        font-family: Arial, sans-serif !important;
                        font-weight: normal !important;
                    }
    
                    #uf-cnf-forced-header-message {
                        position: absolute !important;
                        top: 0px !important;
                        left: 10px !important;
                        padding: 5px !important;
                        z-index: 2147483647 !important;
                        color: #fff;
                        text-align: initial !important;
                        width: 250px !important;
                        font-size: 40px !important;
                        height: 41px !important;
                        box-sizing: border-box !important;
                        border: none !important;
                        font-family: Arial, sans-serif !important;
                        font-weight: normal !important;
                        line-height: 1.5 !important;
                    }
                    
                    .uf-cnf-forced-header-message-success1 {
                        color: #00ff15 !important;
                    }
                    .uf-cnf-forced-header-message-success2 {
                        color: #1bd4db !important
                    }
                    .uf-cnf-forced-header-message-failed {
                        color: red !important;
                    }
    
                    body {
                        margin-top: 80px !important;
                    }
                
                    #uf-cnf-csv_log_status_label {
                        display: inline !important;
                        margin-bottom: 5px !important;
                        font-family: Noto Sans !important;
                        font-size: 12px !important;
                        font-weight: 700 !important;
                        line-height: 46px !important;
                        letter-spacing: 0px !important;
                        text-align: left !important;
                        color: white !important;
                    }
                    .uf-cnf-header-container {
                        display: flex !important;
                        justify-content: center !important;
                        align-items: center !important;
                        flex-wrap: wrap !important;
                    }
                </style>
        
                
                <script>
                    // UFヘッダーのステータス変更
                    var selectElement = document.querySelector("select[name='uf-cnf-csv_log_status']");
                    if (selectElement) {
                        // console.log("select 要素が見つかりました。イベントリスナーを追加します。");
                        selectElement.addEventListener("change", function(event) {
                            var selectedValue = event.target.value;
                            // console.log("選択された値:", selectedValue);
                            var uf_cnf_csv_log_csv_id = document.getElementById("uf-cnf-csv_log_csv_id");
                            var uf_cnf_csv_log_memo = document.getElementById("uf-cnf-csv_log_memo");
                            
                            var uf_cnf_csv_log_csv_id_value = uf_cnf_csv_log_csv_id ? uf_cnf_csv_log_csv_id.value : null;
                            var uf_cnf_csv_log_memo_value = uf_cnf_csv_log_memo ? uf_cnf_csv_log_memo.value : null;
                            window.postMessage({ type: "ULT_CNF_exHeader", "ULT_CNF_exHeader_csv_log_status": selectedValue, "ULT_CNF_exHeader_csv_id": uf_cnf_csv_log_csv_id_value, "ULT_CNF_exHeader_type": "status" }, '*');
                        });
                    } else {
                        console.warn("select[name='uf-cnf-csv_log_status'] 要素が見つかりませんでした。");
                    }
                    
                    // UFヘッダーのメモ変更
                    var memoElement = document.getElementById("uf-cnf-csv_log_memo");
                    if (memoElement) {
                        // console.log("メモ要素が見つかりました。イベントリスナーを追加します。");
                        memoElement.addEventListener("blur", function(event) {
                            var memoValue = event.target.value;
                            // console.log("入力されたメモ:", memoValue);
                            var uf_cnf_csv_log_csv_id = document.getElementById("uf-cnf-csv_log_csv_id");
                            
                            var uf_cnf_csv_log_csv_id_value = uf_cnf_csv_log_csv_id ? uf_cnf_csv_log_csv_id.value : null;
                            window.postMessage({ type: "ULT_CNF_exHeader", "ULT_CNF_exHeader_csv_id": uf_cnf_csv_log_csv_id_value, "ULT_CNF_exHeader_csv_log_memo": memoValue, "ULT_CNF_exHeader_type": "memo" }, '*');
                        });
                    } else {
                        console.warn("id='uf-cnf-csv_log_memo' 要素が見つかりませんでした。");
                    }
                
                    var closeButton = document.getElementById("uf-cnf-forced-header-close-button");
                    if (closeButton) {
                        closeButton.addEventListener("click", function() {
                            var headerElement = document.getElementById("uf-cnf-forced-header");
                            if (headerElement) {
                                // headerElement.style.display = "none";
                                document.getElementById("uf-cnf-forced-header").remove();
    
                            }
                        });
                    }
                </script>
            `);
            // document.getElementById("uf-cnf-forced-header").remove();
            
        }
    
        
    });
});


function main(resultData) {
    // console.log("main");
    // console.log(resultData);
    chrome.storage.local.get(null, function (data) {
        Object.entries(data).map(([name, obj]) => {
            if (obj.tagName == "問い合わせ内容") {
                var jsonLpUrl = JSON.parse(resultData.lpUrl);
                Object.keys(jsonLpUrl).forEach(function (key) {
                    var reg = "{LP_URL"+key+"}";
                    obj.val = obj.val.replace(new RegExp(reg,'g'), jsonLpUrl[key]);
                });
                // 変数削除
                var lplurl = [1,2,3];
                Object.keys(lplurl).forEach(function (key) {
                    var reg = "{LP_URL"+lplurl[key]+"}";
                    obj.val = obj.val.replace(new RegExp(reg,'g'), "");
                });

                
                
                // SITE_NAME差し込み
                // ポップアップの自動入力を実行したら走る処理
                let autoSupplyName = z2h(data?.ULT_CNF_autoSupplyTabIds?.[data?.ULT_CNF_tab_id]?.autoSupplyName ?? "");
                if (data.ULT_CNF_target_url == "https://code-company.co.jp/test/") {
                    autoSupplyName = "株式会社CODE COMPANY";
                }
                obj.val = obj.val.replace(/\{SITE_NAME(_[^\}]+)?\}/g, replaceSiteNamePlaceholder);

                function replaceSiteNamePlaceholder(match, placeholderSuffix) {
                    if (!placeholderSuffix) {
                        return autoSupplyName;
                    }

                    const suffix = placeholderSuffix.slice(1); // Remove the leading underscore
                    if (suffix === "N") {
                        return autoSupplyName ? autoSupplyName + "\n" : "";
                    }
                    return autoSupplyName ? autoSupplyName + suffix.trim() : "";
                }

                // CLIENT_STAFF_NAME差し込み
                let autoSupplyClientStaffName = z2h(data?.ULT_CNF_autoSupplyTabIds?.[data?.ULT_CNF_tab_id]?.autoSupplyClientStaffName ?? "");
                if (data.ULT_CNF_target_url == "https://code-company.co.jp/test/") {
                    autoSupplyClientStaffName = "植田 歩";
                }
                obj.val = obj.val.replace(/\{CLIENT_STAFF_NAME(_[^\}]+)?\}/g, replaceClientStaffNamePlaceholder);

                function replaceClientStaffNamePlaceholder(match, placeholderSuffix) {
                    // console.log(placeholderSuffix);
                    if (!placeholderSuffix) {
                        return autoSupplyClientStaffName;
                    }

                    const suffix = placeholderSuffix.slice(1); // Remove the leading underscore
                    if (suffix === "N") {
                        return autoSupplyClientStaffName ? autoSupplyClientStaffName + "\n" : "";
                    }
                    return autoSupplyClientStaffName ? autoSupplyClientStaffName + suffix.trim() : "";
                }
                
                // CLIENT_STAFF_POSITION差し込み
                let autoSupplyClientStaffPosition = z2h(data?.ULT_CNF_autoSupplyTabIds?.[data?.ULT_CNF_tab_id]?.autoSupplyClientStaffPosition ?? "");
                if (data.ULT_CNF_target_url == "https://code-company.co.jp/test/") {
                    autoSupplyClientStaffPosition = "代表取締役";
                }
                obj.val = obj.val.replace(/\{CLIENT_STAFF_POSITION(_[^\}]+)?\}/g, replaceClientStaffPositionPlaceholder);

                function replaceClientStaffPositionPlaceholder(match, placeholderSuffix) {
                    // console.log(placeholderSuffix);
                    if (!placeholderSuffix) {
                        return autoSupplyClientStaffPosition;
                    }

                    const suffix = placeholderSuffix.slice(1); // Remove the leading underscore
                    if (suffix === "N") {
                        return autoSupplyClientStaffPosition ? autoSupplyClientStaffPosition + "\n" : "";
                    }
                    return autoSupplyClientStaffPosition ? autoSupplyClientStaffPosition + suffix.trim() : "";
                }
                                        
            }
            
            // name入力
            if (obj.type == "textarea") {
                $("[name='" + resultData[obj.tagName] + "']").val(obj.val);
            } else if (obj.type == "checkbox" && obj.val == true) {
                $("[name='" + resultData[obj.tagName] + "']").prop("checked", true);
            } else {
                $("[name='" + resultData[obj.tagName] + "']").val(obj.val);
            }

            // ifame----
            var iframe = $('iframe').contents();
            if (obj.type == "textarea") {
                iframe.find("[name='" + resultData[obj.tagName] + "']").text(obj.val);
            } else if (obj.type == "checkbox" && obj.val == true) {
                iframe.find("[name='" + resultData[obj.tagName] + "']").prop("checked", true);
            } else {
                iframe.find("[name='" + resultData[obj.tagName] + "']").val(obj.val);
            }
            // ifame----
        });

        if (resultData["ufInputType"] == "data") {
            Object.entries(data).map(([name, obj]) => {
                if (obj.tagName == "問い合わせ内容") {
                    var jsonLpUrl = JSON.parse(resultData.lpUrl);
                    Object.keys(jsonLpUrl).forEach(function (key) {
                        var reg = "{LP_URL"+key+"}";
                        obj.val = obj.val.replace(new RegExp(reg,'g'), jsonLpUrl[key]);
                    });
                    // 変数削除
                    var lplurl = [1,2,3];
                    Object.keys(lplurl).forEach(function (key) {
                        var reg = "{LP_URL"+lplurl[key]+"}";
                        obj.val = obj.val.replace(new RegExp(reg,'g'), "");
                    });

                    // SITE_NAME差し込み
                    let autoSupplyName = z2h(data?.ULT_CNF_autoSupplyTabIds?.[data?.ULT_CNF_tab_id]?.autoSupplyName ?? "");
                    if (data.ULT_CNF_target_url == "https://code-company.co.jp/test/") {
                        autoSupplyName = "株式会社CODE COMPANY";
                    }
                    obj.val = obj.val.replace(/\{SITE_NAME(_[^\}]+)?\}/g, replaceSiteNamePlaceholder);
    
                    function replaceSiteNamePlaceholder(match, placeholderSuffix) {
                        if (!placeholderSuffix) {
                            return autoSupplyName;
                        }
    
                        const suffix = placeholderSuffix.slice(1); // Remove the leading underscore
                        if (suffix === "N") {
                            return autoSupplyName ? autoSupplyName + "\n" : "";
                        }
                        return autoSupplyName ? autoSupplyName + suffix.trim() : "";
                    }

                    // CLIENT_STAFF_NAME差し込み
                    let autoSupplyClientStaffName = z2h(data?.ULT_CNF_autoSupplyTabIds?.[data?.ULT_CNF_tab_id]?.autoSupplyClientStaffName ?? "");
                    if (data.ULT_CNF_target_url == "https://code-company.co.jp/test/") {
                        autoSupplyClientStaffName = "植田 歩";
                    }
                    obj.val = obj.val.replace(/\{CLIENT_STAFF_NAME(_[^\}]+)?\}/g, replaceClientStaffNamePlaceholder);

                    function replaceClientStaffNamePlaceholder(match, placeholderSuffix) {
                        // console.log(placeholderSuffix);
                        if (!placeholderSuffix) {
                            return autoSupplyClientStaffName;
                        }

                        const suffix = placeholderSuffix.slice(1); // Remove the leading underscore
                        if (suffix === "N") {
                            return autoSupplyClientStaffName ? autoSupplyClientStaffName + "\n" : "";
                        }
                        return autoSupplyClientStaffName ? autoSupplyClientStaffName + suffix.trim() : "";
                    }
                    
                    // CLIENT_STAFF_POSITION差し込み
                    let autoSupplyClientStaffPosition = z2h(data?.ULT_CNF_autoSupplyTabIds?.[data?.ULT_CNF_tab_id]?.autoSupplyClientStaffPosition ?? "");
                    if (data.ULT_CNF_target_url == "https://code-company.co.jp/test/") {
                        autoSupplyClientStaffPosition = "代表取締役";
                    }
                    obj.val = obj.val.replace(/\{CLIENT_STAFF_POSITION(_[^\}]+)?\}/g, replaceClientStaffPositionPlaceholder);

                    function replaceClientStaffPositionPlaceholder(match, placeholderSuffix) {
                        // console.log(placeholderSuffix);
                        if (!placeholderSuffix) {
                            return autoSupplyClientStaffPosition;
                        }

                        const suffix = placeholderSuffix.slice(1); // Remove the leading underscore
                        if (suffix === "N") {
                            return autoSupplyClientStaffPosition ? autoSupplyClientStaffPosition + "\n" : "";
                        }
                        return autoSupplyClientStaffPosition ? autoSupplyClientStaffPosition + suffix.trim() : "";
                    }
                                            
                }
           
                // data-name入力
                if (obj.type == "textarea") {
                    $("[data-name='" + resultData[obj.tagName] + "']").val(obj.val);
                } else if (obj.type == "checkbox" && obj.val == true) {
                    $("[data-name='" + resultData[obj.tagName] + "']").prop("checked", true);
                } else {
                    $("[data-name='" + resultData[obj.tagName] + "']").val(obj.val);
                }
           
                // ifame----
                var iframe = $('iframe').contents();
                if (obj.type == "textarea") {
                    iframe.find("[data-name='" + resultData[obj.tagName] + "']").text(obj.val);
                } else if (obj.type == "checkbox" && obj.val == true) {
                    iframe.find("[data-name='" + resultData[obj.tagName] + "']").prop("checked", true);
                } else {
                    iframe.find("[data-name='" + resultData[obj.tagName] + "']").val(obj.val);
                }
                // ifame----
            });
        }
    });
}

var escape = function (str) {
    return str
        .replace(/\\/g, '\\\\')
        .replace(/'/g, "\\'")
        .replace(/"/g, '\\"')
        .replace(/\[/g, '\\[')
        .replace(/]/g, '\\]')
        .replace(/:/g, "\\:")
        .replace(/\//g, '\\/');
};

function isEmpty(obj) {
    return !Object.keys(obj).length;
}

/*
関数概要：引数のDOMからiframeのHTMLの文字列を再帰的に検索し、配列を返却
引数：dom iframeを再帰検索したいDOM
戻り値：検索にヒットしたiframeの配列
*/
function findIframe(targetDom) {
    console.log("findIframe");
    // 結果を格納する配列
    var resultHtmlArray = [];
    // iframeタグを取得
    var iframes = targetDom.getElementsByTagName("iframe");
    // 取得したiframeからHTMLを配列で取得
    Array.prototype.slice.call(iframes).forEach(iframe => {
        try {
            // iframeの内部を取得
            var iframeInnerDom = iframe.contentWindow.document;
            resultHtmlArray.push(iframeInnerDom.body.outerHTML);
            // 内部のiframeを再帰的に検索し結果に格納
            resultHtmlArray = resultHtmlArray.concat(findIframe(iframeInnerDom));
        } catch (e) {
            // iframeのアクセスが拒否されたら処理は正常として、処理を飛ばす
            if (e.name != "SecurityError") {
                throw e;
            }
        }
    });
    return resultHtmlArray;
}

// モーダル閉じる処理
$(document).on('click',function(e) {
    if(!$(e.target).closest('#uf-cnf-modal-overlay').length) {
        if($('#menuCloseUnit').length){
            $("#uf-cnf-modal-overlay").remove();
        }
    }
});

var isLock = false;
var clientX =0;
var clientY =0;
chrome.storage.local.get(null, function (storageData) {
    isLock =  storageData.ULT_CNF_inputSupport_isLock;
    clientX = parseInt(storageData.ULT_CNF_inputSupport_clientX) || 0;
    clientY = parseInt(storageData.ULT_CNF_inputSupport_clientY) || 0;
    localStorage.setItem("ULT_CNF_inputSupport_clientX", storageData.ULT_CNF_inputSupport_clientX);
    localStorage.setItem("ULT_CNF_inputSupport_clientY", storageData.ULT_CNF_inputSupport_clientY);
});

// イベントリスナーを追加
window.addEventListener('message', function(event) {
    if (event.source != window) return;
    if (event.data.type && event.data.type === 'ULT_CNF_inputSupport_isLock') {
        isLock =  event.data.ULT_CNF_inputSupport_isLock;
        console.log("isLock", isLock);
        localStorage.setItem("ULT_CNF_inputSupport_isLock", event.data.ULT_CNF_inputSupport_isLock);
        chrome.storage.local.set({
            "ULT_CNF_inputSupport_isLock": event.data.ULT_CNF_inputSupport_isLock
        });
    }
    if (event.data.type && event.data.type === 'ULT_CNF_inputSupport_clientXY') {
        if (isLock) {
            console.log("event.data.ULT_CNF_inputSupport_clientX", event.data.ULT_CNF_inputSupport_clientX);
            console.log("event.data.ULT_CNF_inputSupport_clientY", event.data.ULT_CNF_inputSupport_clientY);
            console.log("clientX", clientX);
            console.log("clientY", clientY);

            localStorage.setItem("ULT_CNF_inputSupport_clientX", parseInt(event.data.ULT_CNF_inputSupport_clientX));
            localStorage.setItem("ULT_CNF_inputSupport_clientY", parseInt(event.data.ULT_CNF_inputSupport_clientY));
            chrome.storage.local.set({
                "ULT_CNF_inputSupport_clientX": event.data.ULT_CNF_inputSupport_clientX,
                "ULT_CNF_inputSupport_clientY": event.data.ULT_CNF_inputSupport_clientY
            });
        }
    }
    
    // ult.js
    if (event.data.type && event.data.type === 'ULT_CNF_exHeader') {
        // 受信したデータを表示
        var csv_id = event.data.ULT_CNF_exHeader_csv_id;
        var csv_log_status = event.data.ULT_CNF_exHeader_csv_log_status;
        var csv_log_memo = event.data.ULT_CNF_exHeader_csv_log_memo;
        // console.log("csv_id:" + csv_id);
        // console.log("csv_log_status:" + csv_log_status);
        // console.log("csv_log_memo:" + csv_log_memo);
        if (csv_id != "") {
            chrome.storage.local.get(function (data) {
                var authToken = data.ULT_CNF_token;
    
                // background.js へメッセージを送信
                chrome.runtime.sendMessage({
                    type: "makeAjaxRequest", 
                    authToken: authToken,
                    csv_log_status: csv_log_status,
                    csv_id: csv_id,
                    csv_log_memo: csv_log_memo,
    
                });
                
                if (event.data.ULT_CNF_exHeader_type == "status") {
                    $("body").append(`
                        <script>
                            var messageElement = document.getElementById("uf-cnf-forced-header-message");
                            if (messageElement) {
                                // messageElement.textContent = "ステータス記録完了 ";
                                // messageElement.textContent = "● ";
                                // messageElement.style.color = "#00ff15 !important";
                                messageElement.classList.remove("uf-cnf-forced-header-message-success2");
                                messageElement.classList.remove("uf-cnf-forced-header-message-failed");
                                messageElement.classList.add("uf-cnf-forced-header-message-success1");
                            }
                        </script>
                    `);
                }
                if (event.data.ULT_CNF_exHeader_type == "memo") {
                    $("body").append(`
                        <script>
                            var messageElement = document.getElementById("uf-cnf-forced-header-message");
                            if (messageElement) {
                                // messageElement.textContent = "メモ記録完了 ";
                                messageElement.classList.remove("uf-cnf-forced-header-message-success1");
                                messageElement.classList.remove("uf-cnf-forced-header-message-failed");
                                messageElement.classList.add("uf-cnf-forced-header-message-success2");
                                // messageElement.style.color = "blue !important";
                            }
                        </script>
                    `);
                }
            });
        }else{
            console.log("CSV IDが取得できませんでした。");
            $("body").append(`
                <script>
                    var messageElement = document.getElementById("uf-cnf-forced-header-message");
                    if (messageElement) {
                        // messageElement.textContent = "記録に失敗しました。";
                        messageElement.classList.remove("uf-cnf-forced-header-message-success1");
                        messageElement.classList.remove("uf-cnf-forced-header-message-success2");
                        messageElement.classList.add("uf-cnf-forced-header-message-failed");
                        // messageElement.style.color = "red !important";
                    } else {
                        // console.warn("id='uf-cnf-forced-header-message' 要素が見つかりませんでした。");
                    }
                </script>
            `);

        }
    }


    
}, false);

// 入力パッド：画面上のinputをクリックすると入力候補が表示される機能
$('input,textarea').on('click', function(e) {
    console.log("input click");
    if (inputSupport == false ||  typeof inputSupport == 'undefined') {
        return;
    }

    if (clientX == 0) {
        clientX = e.clientX;
    }
    if (clientY == 0) {
        clientY = e.clientY;
    }
    clientX = e.clientX;
    clientY = e.clientY;
    console.log("clientX", clientX);
    console.log("clientY", clientY);

    var clientWidth = document.documentElement.clientWidth;
    var clientHeight = document.documentElement.clientHeight;
    // 入力パッドサイズ
    let padSizeX = 398;
    let padSizeY = 570;

    console.log("isLock", isLock);
    // 入力パッドの位置固定を行うかどうか
    if (isLock) {
        console.log("isLock true");

        if (clientX === 0) clientX = e.clientX;
        if (clientY === 0) clientY = e.clientY;

        function getValueOrDefault(key, defaultValue) {
            const value = localStorage.getItem(key);
            return value !== null ? parseInt(value) : defaultValue;
        }
        console.log("clientX", clientX);
        console.log("clientY", clientY);
        let clientXnew = getValueOrDefault("ULT_CNF_inputSupport_clientX", clientX);
        let clientYnew = getValueOrDefault("ULT_CNF_inputSupport_clientY", clientY);
        if (clientX != clientXnew) {
            clientX = parseInt(localStorage.getItem("ULT_CNF_inputSupport_clientX"))
        }
        if (clientY != clientYnew) {
            clientY = parseInt(localStorage.getItem("ULT_CNF_inputSupport_clientY"))
        }
        console.log("clientX", clientX);
        console.log("clientY", clientY);
        if (isNaN(clientX) || isNaN(clientY)) {
            console.log("isNaN true3");
            clientX = 0;
            clientY = 0;
        }else{
            if (clientX === 0) clientX = clientXnew;
            if (clientY === 0) clientY = clientYnew;
        }
    }else{
        clientX = e.clientX;
        clientY = e.clientY;

        clientX = clientX-50;
        clientY = clientY-(padSizeY/2);
        if (clientX >= clientWidth-padSizeX) {
            clientX = clientWidth-padSizeX;
        }
        if (clientY >= clientHeight-padSizeY) {
            clientY = clientHeight-padSizeY;
        }
        if (clientY <= 0) {
            clientY = clientY-clientY;
        }
    }
    console.log("clientX", clientX);
    console.log("clientY", clientY);
    // バックグラウンドページにメッセージを送信
    // var data = {
    //     isLock: isLock,
    //     clientX: clientX,
    //     clientY: clientY,
    // };
    // chrome.runtime.sendMessage(data);
    

        
    var supportTargetName = e.target.name;
    var ufCnfVId = "ufCnf_"+Date.now();
    $(e.target).attr('data-uf-cnf-vid', ufCnfVId);

    $("#uf-cnf-modal-overlay").remove();
    // $("#uf-cnf-forced-header").remove();
    $("body").append("<div id='uf-cnf-modal-overlay'></div>");

    chrome.storage.local.get(null, function (storageData) {
        var menuCount = 0;
        var closeBtnCount = 0;

        let keyOrder = ['26','25','br','27','28','br','4','2','3','br','4','2','3','br','5','0','1','br','23','br','10','11','12','13','br','7','8',
        '9','br','18','br','19','20','21','22','br','31','29','30','6'
        ,'ULT_CNF_abTag','ULT_CNF_csvTag','ULT_CNF_clipCopymain','ULT_CNF_inputSupport','ULT_CNF_submit_url',
        'ULT_CNF_tab_id','ULT_CNF_targetLpUrl','ULT_CNF_target_url'];

        data = keyOrder.map(key => {
            if (key == "br") {
                return {tagName: 'br'}
            }
            return storageData[key]
        })

        Object.entries(data).map(([name, obj]) => {
            const exclusionArr = ["メールアドレス(確認)","targetLpUrl1","targetLpUrl2","targetLpUrl3","個人情報保護方針","入力補助機能","ULT_CNF_abTag","ULT_CNF_csvTag"];
            if (typeof obj !== 'undefined') {
                if (exclusionArr.indexOf(obj.tagName) === -1) {
                    if (obj.val != "" && typeof obj.val !== 'undefined') {
                        if (closeBtnCount < 1) {
                            $("#uf-cnf-modal-overlay").append('<a id="menuCloseUnit" onclick="menuCloseUnit(this);" class="menuCloseUnit" href="javascript:void(0)">X</a><br id="menuCloseUnitBr">');
                        }
                        closeBtnCount++;

                        if (obj.tagName == "問い合わせ内容") {
                            var jsonLpUrl = JSON.parse(storageData.ULT_CNF_targetLpUrl);
                            var pushText = obj.val;
                            var lplurl = [1,2,3];
                            Object.keys(jsonLpUrl).forEach(function (key) {
                                var tgtext = key.replace(new RegExp("targetLpUrl",'g'), "");
                                var reg = "{LP_URL"+tgtext+"}";
                                pushText = pushText.replace(new RegExp(reg,'g'), jsonLpUrl[key]);
                            });
                            // 変数削除
                            Object.keys(lplurl).forEach(function (key) {
                                var reg = "{LP_URL"+lplurl[key]+"}";
                                pushText = pushText.replace(new RegExp(reg,'g'), "");
                            });

                            // ここだけは他と書き方が違うので注意。pushText = pushText.replace
                            // SITE_NAME差し込み
                            let autoSupplyName = z2h(data?.ULT_CNF_autoSupplyTabIds?.[data?.ULT_CNF_tab_id]?.autoSupplyName ?? "");
                            if (data.ULT_CNF_target_url == "https://code-company.co.jp/test/") {
                                autoSupplyName = "株式会社CODE COMPANY";
                            }
                            pushText = pushText.replace(/\{SITE_NAME(_[^\}]+)?\}/g, replaceSiteNamePlaceholder);
            
                            function replaceSiteNamePlaceholder(match, placeholderSuffix) {
                                if (!placeholderSuffix) {
                                    return autoSupplyName;
                                }
            
                                const suffix = placeholderSuffix.slice(1); // Remove the leading underscore
                                if (suffix === "N") {
                                    return autoSupplyName ? autoSupplyName + "\n" : "";
                                }
                                return autoSupplyName ? autoSupplyName + suffix.trim() : "";
                            }

                            // CLIENT_STAFF_NAME差し込み
                            let autoSupplyClientStaffName = z2h(data?.ULT_CNF_autoSupplyTabIds?.[data?.ULT_CNF_tab_id]?.autoSupplyClientStaffName ?? "");
                            if (data.ULT_CNF_target_url == "https://code-company.co.jp/test/") {
                                autoSupplyClientStaffName = "植田 歩";
                            }
                            pushText = pushText.replace(/\{CLIENT_STAFF_NAME(_[^\}]+)?\}/g, replaceClientStaffNamePlaceholder);
            
                            function replaceClientStaffNamePlaceholder(match, placeholderSuffix) {
                                if (!placeholderSuffix) {
                                    return autoSupplyClientStaffName;
                                }
            
                                const suffix = placeholderSuffix.slice(1); // Remove the leading underscore
                                if (suffix === "N") {
                                    return autoSupplyClientStaffName ? autoSupplyClientStaffName + "\n" : "";
                                }
                                return autoSupplyClientStaffName ? autoSupplyClientStaffName + suffix.trim() : "";
                            }
                            
                            // CLIENT_STAFF_POSITION差し込み
                            let autoSupplyClientStaffPosition = z2h(data?.ULT_CNF_autoSupplyTabIds?.[data?.ULT_CNF_tab_id]?.autoSupplyClientStaffPosition ?? "");
                            if (data.ULT_CNF_target_url == "https://code-company.co.jp/test/") {
                                autoSupplyClientStaffPosition = "代表取締役";
                            }
                            pushText = pushText.replace(/\{CLIENT_STAFF_POSITION(_[^\}]+)?\}/g, replaceClientStaffPositionPlaceholder);
            
                            function replaceClientStaffPositionPlaceholder(match, placeholderSuffix) {
                                if (!placeholderSuffix) {
                                    return autoSupplyClientStaffPosition;
                                }
            
                                const suffix = placeholderSuffix.slice(1); // Remove the leading underscore
                                if (suffix === "N") {
                                    return autoSupplyClientStaffPosition ? autoSupplyClientStaffPosition + "\n" : "";
                                }
                                return autoSupplyClientStaffPosition ? autoSupplyClientStaffPosition + suffix.trim() : "";
                            }
                            

                            // 効果測定URLを含んだ本文貼り付け処理
                            disabled = true;
                            var urlCheck = false;
                            chrome.storage.local.get("ULT_CNF_target_url", function (data) {
                                target_url = data.ULT_CNF_target_url;
                                var location_href_url = location.href;
                                if (target_url == location_href_url) {
                                    urlCheck = true;
                                }
                            });
                            chrome.storage.local.get("ULT_CNF_targetLpUrl", function (data) {
                                targetLpUrl = data.ULT_CNF_targetLpUrl;
                            });
                            chrome.storage.local.get("ULT_CNF_abTag", function (data) {
                                abTag = data.ULT_CNF_abTag;
                            });
                            chrome.storage.local.get("ULT_CNF_csvTag", function (data) {
                                csvTag = data.ULT_CNF_csvTag;
                            });
                            
                            chrome.storage.local.get("ULT_CNF_clipCopymain", function (data) {
                                ULT_CNF_clipCopymain = data.ULT_CNF_clipCopymain;
                                if (typeof ULT_CNF_clipCopymain !== 'undefined' && urlCheck) {
                                    pushText=ULT_CNF_clipCopymain;
                                    $("#menuCloseUnitBr").after("<a id='sid_"+obj.tagName+"' data-uf-cnf-vid='"+ufCnfVId+"' data-sname='"+obj.tagName+"' data-starname='"+supportTargetName+"' data-sval='"+pushText+"' onclick='menuUnit(this);' class='menuUnit' href='javascript:void(0)'>本文(効測URLあり)</a>");
                                }else{
                                    $("#menuCloseUnitBr").after("<a id='sid_"+obj.tagName+"' data-uf-cnf-vid='"+ufCnfVId+"' data-sname='"+obj.tagName+"' data-starname='"+supportTargetName+"' data-sval='"+pushText+"' onclick='menuUnit(this);' class='menuUnit4' href='javascript:void(0)'>本文(効測URLなし)</a>");
                                }
                            });
                        }else{
                            var menuUnitClass = "menuUnit";
                            if ( obj.tagName.match(/メールアドレス|電話番号/)) {
                            }
                            if ( obj.tagName.match(/^フリガナ$|ふりがな|名前|姓|^名$/)) {
                                menuUnitClass = "menuUnit3"
                            }
                            if ( obj.tagName.match(/郵便番号|都道府県|市区町村|番地|建物名|住所/)) {
                                menuUnitClass = "menuUnit3"
                            }

                            var objTagName = obj.tagName;
                            if ( obj.tagName.match(/電話番号(.)/)) {
                                var nomalreg = obj.tagName.match(/電話番号(.)/);
                                objTagName = nomalreg[1];
                            }
                            if ( obj.tagName.match(/郵便番号(.)/)) {
                                var nomalreg = obj.tagName.match(/郵便番号(.)/);
                                objTagName = nomalreg[1];
                            }
                            if (objTagName == "会社名") {
                                objTagName = "会社名";
                            }
                            if (objTagName == "名前") {
                                objTagName = "名前";
                            }
                            if (objTagName == "メールアドレス") {
                                objTagName = "メールアドレス";
                            }
                            if (objTagName == "電話番号") {
                                objTagName = "電話番号";
                            }
                            if (objTagName == "郵便番号") {
                                objTagName = "郵便番号";
                            }
                            if (objTagName == "住所") {
                                objTagName = "住所";
                            }

                            if (objTagName == "フリガナ") {
                                objTagName = "ふりがな";
                                obj.tagName = "ふりがな";
                                obj.val = katakanaToHiragana(obj.val);
                            }
                            if (objTagName == "ふりがな１") {
                                objTagName = "せい";
                                obj.val = katakanaToHiragana(obj.val);
                            }
                            if (objTagName == "ふりがな２") {
                                objTagName = "めい";
                                obj.val = katakanaToHiragana(obj.val);
                            }
                            function katakanaToHiragana(str) {
                                return str.replace(/[\u30A1-\u30FA]/g, ch =>
                                  String.fromCharCode(ch.charCodeAt(0) - 0x60)
                                );
                            }

                            if (name > 8) {
                                if (objTagName == "ふりがな") {
                                    objTagName = "フリガナ";
                                    obj.val = hiraganaToKatakana(obj.val);
                                    obj.tagName = "フリガナ";
                                }
                                if (objTagName == "せい") {
                                    objTagName = "セイ";
                                    obj.tagName = "セイ";
                                    obj.val = hiraganaToKatakana(obj.val);
                                }
                                if (objTagName == "めい") {
                                    objTagName = "メイ";
                                    obj.tagName = "メイ";
                                    obj.val = hiraganaToKatakana(obj.val);
                                }
                                function hiraganaToKatakana(str) {
                                    return str.replace(/[\u3041-\u3096]/g, ch =>
                                      String.fromCharCode(ch.charCodeAt(0) + 0x60)
                                    );
                                }
                            }

                            if (objTagName == "会社名(フリガナ)") {
                                objTagName = "カイシャメイ";
                            }
                            
                            $("#uf-cnf-modal-overlay").append("<a id='sid_"+obj.tagName+"' data-uf-cnf-vid='"+ufCnfVId+"' data-sname='"+obj.tagName+"' data-starname='"+supportTargetName+"' data-sval='"+obj.val+"' onclick='menuUnit(this);' class='"+menuUnitClass+"' href='javascript:void(0)'>"+objTagName+"</a>");
                            menuCount++;
                        }
                    }else{
                        if (obj.tagName == "br") {
                            $("#uf-cnf-modal-overlay").append("<br>");
                        }
                    }
                }
            }
        });

        var checkedAttribute = isLock === true ? 'checked' : '';
        
        $("#uf-cnf-modal-overlay").append(`
        <span style="position: relative; display: flex; align-items: center; color: white;">
            <input type="checkbox" id="fix-pad-position"
                    style="font-family: -apple-system, BlinkMacSystemFont, 'Helvetica Neue', 'Segoe UI', 'Yu Gothic', YuGothic, sans-serif !important; text-decoration: none!important; font-weight: normal!important; margin: -5px 4px 0; margin-top: 1px 9px; width: 16px; line-height: normal; appearance: auto !important; display: block; font-size: 15px !important;" ${checkedAttribute}>
            <label style="font-family: -apple-system, BlinkMacSystemFont, 'Helvetica Neue', 'Segoe UI', 'Yu Gothic', YuGothic, sans-serif !important; text-decoration: none!important; font-weight: normal!important; color: white !important; background: unset !important; font-size: 15px !important;" for="fix-pad-position">入力パッドの位置を固定する</label>
        </span>
        
        <span style="font-family: -apple-system, BlinkMacSystemFont, 'Helvetica Neue', 'Segoe UI', 'Yu Gothic', YuGothic, sans-serif !important; text-decoration: none!important; font-weight: normal!important; position: relative;display: block; bottom: 10px;margin-top: 15px; height: 10px; color: #009cff !important; font-size: 15px !important;">
            <a style="font-family: -apple-system, BlinkMacSystemFont, 'Helvetica Neue', 'Segoe UI', 'Yu Gothic', YuGothic, sans-serif !important; text-decoration: none!important; font-weight: normal!important; color: #009cff !important;" href="https://ultra-form.code-company.co.jp/img/inputsupport_manual.png" target="_brank">入力パッド(入力補助機能)をOFFにする方法</a>
        </span>
        <span style="font-family: -apple-system, BlinkMacSystemFont, 'Helvetica Neue', 'Segoe UI', 'Yu Gothic', YuGothic, sans-serif !important; text-decoration: none!important; font-weight: normal!important; position: relative;display: block; bottom: 10px; margin-top: 10px; height: 0px; color: white !important; font-size: 15px !important;">Ultra Form / CODE COMPANY Ltd. </span>
        `);

        $("body").append(`<script>
            document.getElementById("fix-pad-position").addEventListener("change", function() {
                if (this.checked) {
                    window.postMessage({ type: "ULT_CNF_inputSupport_isLock", ULT_CNF_inputSupport_isLock: true }, '*');
                } else {
                    window.postMessage({ type: "ULT_CNF_inputSupport_isLock", ULT_CNF_inputSupport_isLock: false }, '*');
                }
            });
        </script>`);
    
    
        
        return true;
    });

    var menuUnitColor = "#029e87";
    var menuUnitColor2 = "#00b096";
    var menuUnitColor3 = "#0782e0";
    var menuUnitColor4 = "#afa614";
    var fontSize = "15";
    $("body").append("<style>#uf-cnf-modal-overlay{line-height: 28px !important; text-align: left !important;}</style>");
    $("body").append("<style>.menuUnit {line-height: 28px !important;font-family: -apple-system, BlinkMacSystemFont, 'Helvetica Neue', 'Segoe UI', 'Yu Gothic', YuGothic, sans-serif !important;font-size: "+fontSize+"px!important;color: #fff !important;text-decoration: none !important;display: inline-block!important;position: relative!important;padding: 4px 15px!important;margin: 5px!important;box-sizing: border-box!important;max-width: 180px!important;height: 36px!important;border: 0!important;background: "+menuUnitColor+"!important;background: -moz-linear-gradient(left, "+menuUnitColor+" 0%, #71e0ad 100%)!important;filter: progid:DXImageTransform.Microsoft.gradient(startColorstr='"+menuUnitColor+"', endColorstr='#71e0ad', GradientType=1)!important;color: #fff!important;font-weight: normal!important;cursor: pointer!important;text-align: center!important;transition: opacity .4s ease-out!important;}</style>");
    $("body").append("<style>.menuUnit2 {line-height: 28px !important;font-family: -apple-system, BlinkMacSystemFont, 'Helvetica Neue', 'Segoe UI', 'Yu Gothic', YuGothic, sans-serif !important;font-size: "+fontSize+"px!important;color: #fff !important;text-decoration: none !important;display: inline-block!important;position: relative!important;padding: 4px 15px!important;margin: 5px!important;box-sizing: border-box!important;max-width: 180px!important;height: 36px!important;border: 0!important;background: "+menuUnitColor2+"!important;background: -moz-linear-gradient(left, "+menuUnitColor2+" 0%, #71e0ad 100%)!important;filter: progid:DXImageTransform.Microsoft.gradient(startColorstr='"+menuUnitColor2+"', endColorstr='"+menuUnitColor2+"', GradientType=1)!important;color: #fff!important;font-weight: normal!important;cursor: pointer!important;text-align: center!important;transition: opacity .4s ease-out!important;}</style>");
    $("body").append("<style>.menuUnit3 {line-height: 28px !important;font-family: -apple-system, BlinkMacSystemFont, 'Helvetica Neue', 'Segoe UI', 'Yu Gothic', YuGothic, sans-serif !important;font-size: "+fontSize+"px!important;color: #fff !important;text-decoration: none !important;display: inline-block!important;position: relative!important;padding: 4px 15px!important;margin: 5px!important;box-sizing: border-box!important;max-width: 180px!important;height: 36px!important;border: 0!important;background: "+menuUnitColor3+"!important;background: -moz-linear-gradient(left, "+menuUnitColor3+" 0%, #71e0ad 100%)!important;filter: progid:DXImageTransform.Microsoft.gradient(startColorstr='"+menuUnitColor3+"', endColorstr='"+menuUnitColor3+"', GradientType=1)!important;color: #fff!important;font-weight: normal!important;cursor: pointer!important;text-align: center!important;transition: opacity .4s ease-out!important;}</style>");
    $("body").append("<style>.menuUnit4 {line-height: 28px !important;font-family: -apple-system, BlinkMacSystemFont, 'Helvetica Neue', 'Segoe UI', 'Yu Gothic', YuGothic, sans-serif !important;font-size: "+fontSize+"px!important;color: #fff !important;text-decoration: none !important;display: inline-block!important;position: relative!important;padding: 4px 15px!important;margin: 5px!important;box-sizing: border-box!important;max-width: 180px!important;height: 36px!important;border: 0!important;background: "+menuUnitColor4+"!important;background: -moz-linear-gradient(left, "+menuUnitColor4+" 0%, #71e0ad 100%)!important;filter: progid:DXImageTransform.Microsoft.gradient(startColorstr='"+menuUnitColor4+"', endColorstr='"+menuUnitColor4+"', GradientType=1)!important;color: #fff!important;font-weight: normal!important;cursor: pointer!important;text-align: center!important;transition: opacity .4s ease-out!important;}</style>");
    
    $("body").append("<style>#uf-cnf-modal-overlay {padding: 21px !important;width: auto!important;height: auto!important;position: fixed!important;top: "+clientY+"px;left: "+clientX+"px;z-index: 9999!important;position: fixed!important;background: rgb(0 0 0 / 60%)!important;}</style>");
    
    $("body").append("<style>.menuCloseUnit {font-size: 15px!important;color: #fff!important;text-decoration: none!important;display: inline-block;position: relative;padding: 0px 0px 0px 7px;}</style>");

    $("body").append(`<script>
    function menuUnit(obj) {
        var uf_cnf_element = document.getElementById(obj.id);
        if (uf_cnf_element.dataset.starname != "") {
            document.getElementsByName(uf_cnf_element.dataset.starname)[0].value = uf_cnf_element.dataset.sval;
        }else{
            var ufCnfVid = uf_cnf_element.dataset.ufCnfVid;
            document.querySelectorAll('[data-uf-cnf-vid="'+ufCnfVid+'"]')[0].value = uf_cnf_element.dataset.sval;
        }
        document.getElementById("uf-cnf-modal-overlay").remove();
    }
    
    function menuCloseUnit(obj) {
        document.getElementById("uf-cnf-modal-overlay").remove();
    }

    // パッド移動
    var isMouseDown = false;
    var mouseMoveHandler;
    var overlay = document.getElementById("uf-cnf-modal-overlay");
    
    overlay.onmousedown = function(e) {
        e.preventDefault(); 
        isMouseDown = true;
        var rect = overlay.getBoundingClientRect();
        var offsetX = e.clientX - rect.left;
        var offsetY = e.clientY - rect.top;
    
        mouseMoveHandler = function(e) {
            if(isMouseDown) {
                overlay.style.left = (e.clientX - offsetX) + 'px';
                overlay.style.top = (e.clientY - offsetY) + 'px';
            }
        };
    
        window.addEventListener('mousemove', mouseMoveHandler);
    };
    
    window.onmouseup = function() {
        isMouseDown = false;
        window.removeEventListener('mousemove', mouseMoveHandler);

        // 新しい座標を取得して保存
        // ここで新しい位置をローカルストレージに保存
        if (overlay.style.left && overlay.style.top) {
            window.postMessage({ type: "ULT_CNF_inputSupport_clientXY", ULT_CNF_inputSupport_clientX: parseInt(overlay.style.left, 10), ULT_CNF_inputSupport_clientY: parseInt(overlay.style.top, 10) }, '*');
        }

    };
    
    </script>`);

    $("body").append("<style>.menuUnit:active, .menuUnit:hover, .menuUnit:focus, .menuUnit2:active, .menuUnit2:hover, .menuUnit2:focus{text-decoration: none !important;background-color: #00c6a9 !important;border-color: #444 !important;color: #fff !important;transition: all 0.35s !important;}</style>");
    $("body").append("<style>.menuUnit3:active, .menuUnit3:hover, .menuUnit3:focus{text-decoration: none !important;background-color: #38a3f5 !important;border-color: #444 !important;color: #fff !important;transition: all 0.35s !important;}</style>");
    $("body").append("<style>.menuUnit4:active, .menuUnit4:hover, .menuUnit4:focus{text-decoration: none !important;background-color: #dbd12a !important;border-color: #444 !important;color: #fff !important;transition: all 0.35s !important;}</style>");

    $("body").append("<style>.menuUnit, .menuUnit2, .menuUnit3, .menuUnit4{border-radius: 5px; !important;}</style>");

});


